using System;
using System.Collections;
using System.Collections.Generic;
using System.IO;
using UnityEngine;
using UnityEngine.Events;

namespace DmcMod
{
    public class DmcMod
    {
        public static void Main()
        {

           
//Ebony and Ivory
                ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Assault Rifle"),
                    NameOverride = "Ebony And Ivory",
                    NameToOrderByOverride = "Pistol",
                    DescriptionOverride = "Dante's personally designed handguns for rapid fire action.",
                    CategoryOverride = ModAPI.FindCategory("Firearms"),
                    ThumbnailOverride = ModAPI.LoadSprite("6.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Ebony.png", 2f); //Коллайдер
                        Instance.FixColliders();
                        if (!Instance.GetComponent<RandomSpriteBehaviour>())
                        Instance.gameObject.AddComponent<RandomSpriteBehaviour>();
                        Instance.GetComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                        {
                            ModAPI.LoadSprite("Ebony.png", 2f),
                            ModAPI.LoadSprite("Ivory.png", 2f),
                        };
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Ivory.png", 2f); //Сам объект
                        var firearm = Instance.GetComponent<FirearmBehaviour>();
                        
                        Cartridge customCartridge = ModAPI.FindCartridge("50 AE"); //Имя патрона
                        customCartridge.name = "Flatline"; //Имя
                        customCartridge.Damage *= 3f; //Урон
                        customCartridge.StartSpeed *= 1f; //Скорость пули
                        customCartridge.PenetrationRandomAngleMultiplier *= 5f; //Точность через объекты
                        customCartridge.Recoil *= 0.2f; //Отдача
                        customCartridge.ImpactForce *= 0f; //Насколько сильно оттолкнет объект
                        firearm.BulletsPerShot = 1; //Пуль за выстрел
                        firearm.AutomaticFireInterval = 0.1f; //Скорострельность
                        firearm.Automatic = false; //Автоматический режим стрельбы или нет
                        firearm.InitialInaccuracy = 0f; //Разброс
                        Instance.GetComponent<FirearmBehaviour>().barrelPosition = new Vector2(0.35f, 0.12f); //От куда вылетит пуля
                        firearm.Cartridge = customCartridge;

                        var phys = Instance.GetComponent<PhysicalBehaviour>();
                        phys.Properties = ModAPI.FindPhysicalProperties("Weapon");
                        phys.TrueInitialMass = 0.10f;
                        phys.InitialMass = 0.10f;
                        phys.rigidbody.mass = 0.10f;
                       
                        firearm.ShotSounds = new AudioClip[] //Звук выстрела
                        {
                           ModAPI.LoadSound("shoot.wav"),
                        };
                    }
                }
            ); 

                //Shotgun
                ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Assault Rifle"),
                    NameOverride = "Coyote-A ",
                    NameToOrderByOverride = "Pistol",
                    DescriptionOverride = "A shotgun firing buckshot, it has been modified for combat use against demonic foes.",
                    CategoryOverride = ModAPI.FindCategory("Firearms"),
                    ThumbnailOverride = ModAPI.LoadSprite("7.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("coyote.png", 2f); //Коллайдер
                        Instance.FixColliders();
                        var firearm = Instance.GetComponent<FirearmBehaviour>();
                        
                        Cartridge customCartridge = ModAPI.FindCartridge("50 AE"); //Имя патрона
                        customCartridge.name = "Flatline"; //Имя
                        customCartridge.Damage *= 5f; //Урон
                        customCartridge.StartSpeed *= 1f; //Скорость пули
                        customCartridge.PenetrationRandomAngleMultiplier *= 5f; //Точность через объекты
                        customCartridge.Recoil *= 0.2f; //Отдача
                        customCartridge.ImpactForce *= 0f; //Насколько сильно оттолкнет объект
                        firearm.BulletsPerShot = 2; //Пуль за выстрел
                        firearm.AutomaticFireInterval = 0.1f; //Скорострельность
                        firearm.Automatic = false; //Автоматический режим стрельбы или нет
                        firearm.InitialInaccuracy = 0f; //Разброс
                        Instance.GetComponent<FirearmBehaviour>().barrelPosition = new Vector2(0.35f, 0.12f); //От куда вылетит пуля
                        firearm.Cartridge = customCartridge;

                        var phys = Instance.GetComponent<PhysicalBehaviour>();
                        phys.Properties = ModAPI.FindPhysicalProperties("Weapon");
                        phys.TrueInitialMass = 0.10f;
                        phys.InitialMass = 0.10f;
                        phys.rigidbody.mass = 0.10f;
                       
                        firearm.ShotSounds = new AudioClip[] //Звук выстрела
                        {
                           ModAPI.LoadSound("again.wav"),
                        };
                    }
                }
            ); 
                //Sword Rebellion
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Sword"), 
                    NameOverride = "Rebellion -DMC", // Name.
                    NameToOrderByOverride = "BBBBB2", //  
                    DescriptionOverride = "A keepsake sword from Dante's father.",// Description
                    CategoryOverride = ModAPI.FindCategory("Melee"),//Category
                    ThumbnailOverride = ModAPI.LoadSprite("4.png", 5f),//Thumbnail
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("rebel.png", 2f);
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.1f;                      
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.1f;
                        
                    }
                }
            );

            //katana Yamato
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"), 
                    NameOverride = "Yamato -DMC", // Name.
                    NameToOrderByOverride = "BBBBB2", //  
                    DescriptionOverride = "A memento from Vergil's father. This samurai-esque sword's blade is said to cut through anything. (press F to open it)",// Description
                    CategoryOverride = ModAPI.FindCategory("Melee"),//Category
                    ThumbnailOverride = ModAPI.LoadSprite("3.png", 5f),//Thumbnail
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("yamato2.png", 1.7f);
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.1f;                      
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.1f;
                        Instance.AddComponent<podarokfake>();
                        Instance.AddComponent<podarokfake2>();
                        Instance.FixColliders();
                    }
                }
            );
            //katana Yamato2
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Sword"), 
                    NameOverride = "Yamato2 -DMC", // Name.
                    NameToOrderByOverride = "BBBBB2", //  
                    DescriptionOverride = "If you want it.. then you will have to take it",// Description
                    CategoryOverride = ModAPI.FindCategory("Meleee"),//Category
                    ThumbnailOverride = ModAPI.LoadSprite("Thumb.png", 5f),//Thumbnail
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.1f;                      
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.1f;
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("yamato.png", 1.7f);

                    }
                }
            );
               //katana Yamato2
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Sword"), 
                    NameOverride = "Mirage blade (summoned swords) -DMC", // Name.
                    NameToOrderByOverride = "BBBBB2", //  
                    DescriptionOverride = "Vergil Shoots these",// Description
                    CategoryOverride = ModAPI.FindCategory("Melee"),//Category
                    ThumbnailOverride = ModAPI.LoadSprite("5.png", 5f),//Thumbnail
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.1f;                      
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.1f;
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("lil.png", 1.7f);
                        Instance.AddComponent<podarokfake3>();
                        Instance.FixColliders();
                        Instance.GetComponent<PhysicalBehaviour>().OverrideImpactSounds = new AudioClip[] 
                             {
                                                          ModAPI.LoadSound("impact1.wav"),
                                                          ModAPI.LoadSound("impact2.wav"),
                                                          ModAPI.LoadSound("impact3.wav"),                                                                             
                                                        }; 
                    }
                }
            );

//hilt
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Plastic Barrel"), 
                    NameOverride = "Hilt -DMC", // Name.
                    NameToOrderByOverride = "BBBBB2", //  
                    DescriptionOverride = "If you want it.. then you will have to take it",// Description
                    CategoryOverride = ModAPI.FindCategory("Meleee"),//Category
                    ThumbnailOverride = ModAPI.LoadSprite("Thumb.png", 5f),//Thumbnail
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("hilt.png", 1.8f);
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.1f;                      
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.1f;
                        foreach(var hitbox2 in Instance.GetComponents<Collider2D>()) { GameObject.Destroy(hitbox2); }                    
                    }
                }
            );
            //Dante
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Dante -DMC",
                    NameToOrderByOverride = "C",
                    DescriptionOverride ="A demon hunter born of the union between the legendary dark knight Sparda and his human bride, he uses his keepsake sword and dual handguns to crush his enemies... After having some fun with them.",
                    CategoryOverride = ModAPI.FindCategory("Entities"),
                    ThumbnailOverride = ModAPI.LoadSprite("2.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var person = Instance.GetComponent<PersonBehaviour>();
                        var skin = ModAPI.LoadTexture("dante.png");
                        var flesh = ModAPI.LoadTexture("dante2.png");
                        var bone = ModAPI.LoadTexture("dante3.png");
                        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone, 1);
                        person.SetBruiseColor(85, 20, 20); //main bruise colour. purple-ish by default
                        person.SetSecondBruiseColor(6, 0, 0); //second bruise colour. red by default
                        person.SetThirdBruiseColor(7, 0, 0); // third bruise colour. light yellow by default
                        person.SetBloodColour(8, 0, 0); // blood clour. dark red by default
                        person.SetRottenColour(0, 0, 0); // rotten/zombie colour. light yellow/green by default
                        foreach (var body in person.Limbs)
                        {
                             body.BaseStrength *= 1f;                            
                             body.Health *= 9999999f;
                             body.BreakingThreshold *= 99999f;  

                             var backpack = new GameObject("Backpack");
                             backpack.transform.SetParent(Instance.transform.Find("Body").Find("UpperBody"));
                             backpack.transform.localPosition = new Vector3(0, 0f);
                             backpack.transform.localScale = new Vector3(1f, 1f);
                             var backpackSprite = backpack.AddComponent<SpriteRenderer>();
                             backpackSprite.sprite = ModAPI.LoadSprite("Cape.png"); 
                             backpack.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                             backpack.AddComponent<UseEventTrigger>().Action = () => {
                             backpackSprite.sprite = ModAPI.LoadSprite("none.png");
                                                                                     }; 

                             var ArmDown = Instance.transform.Find("FrontArm").Find("LowerArmFront");
                             var ArmTop = Instance.transform.Find("FrontArm").Find("UpperArmFront");

                             ArmDown.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                             ArmTop.GetComponent<SpriteRenderer>().sortingLayerName = "Top";


                        }
                    }
                }
            );

             //Vergil
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Vergil -DMC",
                    NameToOrderByOverride = "C",
                    DescriptionOverride ="He is Dante's twin brother. Ever-so-skillfully weilding the Yamato sword, a keepsake from his father, his sword speed is said to be so fast that it appears invisible to the human eye.",
                    CategoryOverride = ModAPI.FindCategory("Entities"),
                    ThumbnailOverride = ModAPI.LoadSprite("1.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var person = Instance.GetComponent<PersonBehaviour>();
                        var skin = ModAPI.LoadTexture("vergil.png");
                        var flesh = ModAPI.LoadTexture("vergil2.png");
                        var bone = ModAPI.LoadTexture("vergil3.png");
                        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone, 1);
                        person.SetBruiseColor(85, 20, 20); //main bruise colour. purple-ish by default
                        person.SetSecondBruiseColor(6, 0, 0); //second bruise colour. red by default
                        person.SetThirdBruiseColor(7, 0, 0); // third bruise colour. light yellow by default
                        person.SetBloodColour(8, 0, 0); // blood clour. dark red by default
                        person.SetRottenColour(0, 0, 0); // rotten/zombie colour. light yellow/green by default
                        foreach (var body in person.Limbs)
                        {
                             body.BaseStrength *= 1f;                            
                             body.Health *= 9999999f;
                             body.BreakingThreshold *= 99999f;  

                             var backpack = new GameObject("Backpack");
                             backpack.transform.SetParent(Instance.transform.Find("Body").Find("UpperBody"));
                             backpack.transform.localPosition = new Vector3(0, 0f);
                             backpack.transform.localScale = new Vector3(1f, 1f);
                             var backpackSprite = backpack.AddComponent<SpriteRenderer>();
                             backpackSprite.sprite = ModAPI.LoadSprite("Cape2.png"); 
                             backpack.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                             backpack.AddComponent<UseEventTrigger>().Action = () => {
                             backpackSprite.sprite = ModAPI.LoadSprite("none.png");
                                                                                     };  
                             var ca = new GameObject("ca");
                             ca.transform.SetParent(Instance.transform.Find("Head"));
                             ca.transform.localPosition = new Vector3(0f, 0.06f, 0f);
                             ca.transform.localScale = new Vector3(1f, 1f);
                             var caSprite = ca.AddComponent<SpriteRenderer>();
                             caSprite.sprite = ModAPI.LoadSprite("Vhair.png"); 
                             ca.GetComponent<SpriteRenderer>().sortingLayerName = "Top";    

                             var ArmDown = Instance.transform.Find("FrontArm").Find("LowerArmFront");
                             var ArmTop = Instance.transform.Find("FrontArm").Find("UpperArmFront");

                             ArmDown.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                             ArmTop.GetComponent<SpriteRenderer>().sortingLayerName = "Top";                          
                        }
                    }
                }
            );

        }
    }
}
public class podarokfake : MonoBehaviour
{
    public void Use()
    {
        StartCoroutine("Rodcraft6");
    }
    IEnumerator Rodcraft6()
    {
        yield return new WaitForSeconds(0.01f);
        //yield return new WaitForSeconds(1f);
        GameObject spawnedObj;
        spawnedObj = UnityEngine.GameObject.Instantiate(ModAPI.FindSpawnable("Hilt -DMC").Prefab, this.transform.position, Quaternion.Euler(0, 0, 0));
        CatalogBehaviour.PerformMod(ModAPI.FindSpawnable("Hilt -DMC"), spawnedObj);
        spawnedObj.transform.position = spawnedObj.transform.position;
        yield return new WaitForSeconds(0.01f);
        GameObject.Destroy(this.gameObject);
    }
}
public class podarokfake2 : MonoBehaviour
{
    public void Use()
    {
        StartCoroutine("Rodcraft6");
    }
    IEnumerator Rodcraft6()
    {
        yield return new WaitForSeconds(0.01f);
        //yield return new WaitForSeconds(1f);
        GameObject spawnedObj;
        spawnedObj = UnityEngine.GameObject.Instantiate(ModAPI.FindSpawnable("Yamato2 -DMC").Prefab, this.transform.position, Quaternion.Euler(0, 0, 0));
        CatalogBehaviour.PerformMod(ModAPI.FindSpawnable("Yamato2 -DMC"), spawnedObj);
        spawnedObj.transform.position = spawnedObj.transform.position;
        yield return new WaitForSeconds(0.01f);
        GameObject.Destroy(this.gameObject);
    }
}
public class podarokfake3 : MonoBehaviour
{
    public void Awake()
    {
        StartCoroutine("Rodcraft6");
    }
    IEnumerator Rodcraft6()
    {
        yield return new WaitForSeconds(3f);
        GameObject.Destroy(this.gameObject);
    }
}
